VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "ErrorHandler test form"
   ClientHeight    =   4008
   ClientLeft      =   48
   ClientTop       =   276
   ClientWidth     =   6252
   LinkTopic       =   "Form1"
   ScaleHeight     =   4008
   ScaleWidth      =   6252
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCustomError 
      Caption         =   "Generate Custom user error"
      Height          =   372
      Left            =   240
      TabIndex        =   5
      Top             =   1620
      Width           =   5832
   End
   Begin VB.CommandButton cmdXmlError 
      Caption         =   "Generate XML error"
      Height          =   372
      Left            =   240
      TabIndex        =   3
      Top             =   1140
      Width           =   5832
   End
   Begin VB.CommandButton cmdVbError 
      Caption         =   "Generate VB error"
      Height          =   372
      Left            =   240
      TabIndex        =   2
      Top             =   660
      Width           =   5832
   End
   Begin VB.CommandButton cmdAdoError 
      Caption         =   "Generate ADO error"
      Height          =   372
      Left            =   240
      TabIndex        =   1
      Top             =   180
      Width           =   5832
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   372
      Left            =   5100
      TabIndex        =   0
      Top             =   3600
      Width           =   1092
   End
   Begin VB.Label lblCopyright 
      Caption         =   "(c)2000-2003 Yuri Volkov, programmer@iname.com"
      Height          =   312
      Left            =   60
      TabIndex        =   4
      Top             =   3600
      Width           =   4992
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const conModuleName = "frmMain"

Public Initialized As Boolean

Private Sub cmdAdoError_Click()
Const conModuleSubName = conModuleName & ":" & "cmdAdoError_Click"
Dim strSql As String
Dim strDescr As String
Dim RecordsAffected As Long
  On Error GoTo ErrProc
  
  strDescr = "Trying to update sometable..."
  strSql = "Update Sometable Set Column1='www'"
  AppGlobals.cnn1.Execute strSql, RecordsAffected, adCmdText
  
ExitProc:
  On Error Resume Next
  Exit Sub
  
ErrProc:
  'This is a call to yvErrorHandler
  ShowErrorSql conModuleSubName, strSql, strDescr
  Resume ExitProc
End Sub

Private Sub cmdClose_Click()
Const conModuleSubName = conModuleName & ":" & "cmdClose_Click"
  On Error GoTo ErrProc
  
  Call ReleaseProgram
  
ExitProc:
  On Error Resume Next
  Exit Sub
  
ErrProc:
  ShowError conModuleSubName
  Resume ExitProc
End Sub

Private Sub cmdCustomError_Click()
Const conModuleSubName = conModuleName & ":" & "cmdCustomError_Click"
Dim strDescr As String
Dim lng1 As Long
Dim CustomErrorNumber As Long
  On Error GoTo ErrProc
  
  strDescr = "I'm checking some app specific constraint"
  lng1 = 2
  If lng1 > 1 Then
    CustomErrorNumber = vbObjectError + 1
    Err.Raise CustomErrorNumber, conModuleSubName, "Some constraint is violated!!!"
  End If
  
ExitProc:
  On Error Resume Next
  Exit Sub
  
ErrProc:
  ShowError conModuleSubName, strDescr
  Resume ExitProc
End Sub

Private Sub cmdVbError_Click()
Const conModuleSubName = conModuleName & ":" & "cmdVbError_Click"
Dim strDescr As String
Dim lng1 As Long
Dim lng2 As Long
  On Error GoTo ErrProc
  
  strDescr = "I'm trying to divide by zero"
  lng1 = 2
  lng1 = lng1 / lng2
  
ExitProc:
  On Error Resume Next
  Exit Sub
  
ErrProc:
  ShowError conModuleSubName, strDescr
  Resume ExitProc
End Sub

Private Sub cmdXmlError_Click()
Const conModuleSubName = conModuleName & ":" & "cmdXmlError_Click"
Dim strDescr As String
Dim doc1 As MSXML2.FreeThreadedDOMDocument40
Dim strXml As String
  On Error GoTo ErrProc
  
  Set doc1 = New MSXML2.FreeThreadedDOMDocument40
  
  strXml = "<document>" & vbLf _
    & "<ww badAttribute=something />" & vbLf _
    & "</document>"
  
  If Not doc1.loadXML( _
    "<?xml version='1.0' encoding='windows-1252' ?>" & vbCrLf & strXml) Then
    ShowError conModuleSubName, "", , doc1.parseError
    GoTo ExitProc
  End If
  
ExitProc:
  On Error Resume Next
  Exit Sub
  
ErrProc:
  ShowError conModuleSubName, strDescr
  Resume ExitProc
End Sub

Private Sub Form_Load()
Const conModuleSubName = conModuleName & ":" & "Form_Load"
  On Error GoTo ErrProc
  
  ' ...
  Me.Caption = Me.Caption & " v." & FullVersionNumber()
  
  Initialized = True
  
ExitProc:
  On Error Resume Next
  Exit Sub
  
ErrProc:
  ShowError conModuleSubName
  Resume ExitProc
  Resume
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  On Error GoTo ExitProc
  If Not Me.Visible Then GoTo ExitProc
  
  ' ...
  
ExitProc:
  On Error Resume Next
  If Not Cancel Then
    Call ReleaseProgram
  End If
  Exit Sub
ErrProc:
  Resume ExitProc
End Sub

Public Sub Release()
Static blnBusy As Boolean
  If blnBusy Then Exit Sub
  blnBusy = True
  
  On Error Resume Next
  
  ' ...
  
  DoEvents
  
ExitProc:
  On Error Resume Next
  blnBusy = False
End Sub

Private Sub Form_Terminate()
Const conModuleSubName = conModuleName & ":" & "Form_Terminate"
  If gblnDebug Then Call MyTrace(conModuleSubName, "", "")
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Call Release
End Sub
